                .LF     rnd8tst.lst
;------------------------------------------------------------------------
;
;  rnd8tst.asm
;
;  Simple test program for 8 bit pseudo random number generator
;
;  Author : San Bergmans
;  Source : www.sbprojects.com
;  Date   : 20-12-2005
;
;------------------------------------------------------------------------
;
;  This is not a very spectacular program. It simply counts the
;  repetition rate of an 8 bit pseudo random number generator.
;  This pseudo random number generator was used in the DICE6 program.
;
;  The program simply starts with a seed of 1 and counts the number of
;  generated pseudo random numbers before a 1 is generated again.
;  The answer from this program (0FFH) proves that the pseudo random
;  number generator repeats after the promised 255 calls.
;
;------------------------------------------------------------------------

                .CR     Z80             Yeah! We're programming the Z80!
                .OR     01800H          RAM starts here, so are we
                .TF     rnd8tst.hex,HEX Create a plain hex dump file

;------------------------------------------------------------------------
;  Monitor routines
;------------------------------------------------------------------------

SCAN            .EQ     005FEH          Scan display until a key pressed
HEX7SG          .EQ     00678H          Convert 2 hex digits to 7-segment

;------------------------------------------------------------------------
;  RND8TEST
;------------------------------------------------------------------------

RND8TEST        LD      IX,DSP_BFFR     Set pointer to display buffer
                LD      B,0             Clear repeat counter
                LD      C,1             Initialize seed

.LOOP           LD      A,C             Calculate next random number
                AND     A,10111000B
                SCF
                JP      PO,.SF
                CCF
.SF             LD      A,C
                RLA
                LD      C,A

                INC     B               Increment iteration counter

                DEC     A               Back at 1?
                JR      NZ,.LOOP        Not yet!

                LD      A,B             Get counter
                LD      HL,DSP_BFFR     Convert to two 7-segment digits
                CALL    HEX7SG
.4EVER          CALL    SCAN            Show this until a key is pressed
                RST     030H            Return to monitor
                JR      RND8TEST        Restart to program if GO pressed

;------------------------------------------------------------------------
;  RAM variables
;------------------------------------------------------------------------

DSP_BFFR        .DA     #0,#0,#0,#0,#0,#0

;------------------------------------------------------------------------

                .LI     OFF
